package cc.fascinated.bat.features.namehistory;

import cc.fascinated.bat.command.Category;
import cc.fascinated.bat.features.Feature;
import cc.fascinated.bat.features.namehistory.command.NameHistoryCommand;
import cc.fascinated.bat.service.CommandService;
import lombok.NonNull;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
public class NameHistoryFeature extends Feature {
    public static final int NAME_HISTORY_SIZE = 25;

    @Autowired
    public NameHistoryFeature(@NonNull ApplicationContext context, @NonNull CommandService commandService) {
        super("Name History", true,Category.UTILITY);

        super.registerCommand(commandService, context.getBean(NameHistoryCommand.class));
    }
}
