package cc.fascinated.bat.features.reminder.command;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.command.CommandInfo;
import lombok.NonNull;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
@CommandInfo(name = "reminder", description = "Set or view reminders.")
public class ReminderCommand extends BatCommand {
    @Autowired
    public ReminderCommand(@NonNull ApplicationContext context) {
        super.addSubCommand(context.getBean(SetSubCommand.class));
        super.addSubCommand(context.getBean(ListSubCommand.class));
        super.addSubCommand(context.getBean(ClearSubCommand.class));
    }
}
