package cc.fascinated.bat.features.welcomer.command;

import cc.fascinated.bat.command.BatSubCommand;
import cc.fascinated.bat.command.CommandInfo;
import cc.fascinated.bat.common.EmbedUtils;
import cc.fascinated.bat.features.welcomer.WelcomerProfile;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import lombok.NonNull;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.channel.concrete.TextChannel;
import net.dv8tion.jda.api.entities.channel.middleman.MessageChannel;
import net.dv8tion.jda.api.interactions.commands.OptionMapping;
import net.dv8tion.jda.api.interactions.commands.OptionType;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component("welcomer:channel.sub")
@CommandInfo(name = "channel", description = "Set the welcomer channel")
public class ChannelSubCommand extends BatSubCommand {
    public ChannelSubCommand() {
        super.addOption(OptionType.CHANNEL, "channel", "The channel to send the welcomer messages to", true);
    }

    @Override
    public void execute(BatGuild guild, @NonNull BatUser user, @NonNull MessageChannel channel, Member member, @NonNull SlashCommandInteraction event) {
        WelcomerProfile profile = guild.getWelcomerProfile();
        OptionMapping channelOption = event.getOption("channel");
        if (channelOption == null) {
            return;
        }
        TextChannel textChannel = channelOption.getAsChannel().asTextChannel();
        profile.setChannel(textChannel);
        event.replyEmbeds(EmbedUtils.successEmbed()
                .setDescription("The welcomer channel has been set to %s".formatted(textChannel.getAsMention()))
                .build()).queue();
    }
}
